﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RowForeColor_FG
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.DataSource = GetData();

            //creating custom styles for faulty and obsolete statuses
            CellStyle cs;
            cs = c1FlexGrid1.Styles.Add("Faulty");
            cs.ForeColor = Color.Red;
            cs = c1FlexGrid1.Styles.Add("Obsolete");
            cs.ForeColor = Color.DarkGray;

            //setting highlight color to blue
            c1FlexGrid1.Styles.Highlight.BackColor = Color.LightBlue;

            c1FlexGrid1.DrawMode = DrawModeEnum.OwnerDraw;
            c1FlexGrid1.OwnerDrawCell += C1FlexGrid1_OwnerDrawCell;
        }

        private void C1FlexGrid1_OwnerDrawCell(object sender, C1.Win.C1FlexGrid.OwnerDrawCellEventArgs e)
        {
            //if column is status and rows in not fixed 
            if (e.Row >= c1FlexGrid1.Rows.Fixed )
            {
                var row = c1FlexGrid1.Rows[e.Row];
                //applying styles to rows according to e.Text property
                if(row["Status"].ToString() == "Faulty")
                {
                    e.Style = c1FlexGrid1.Styles["Faulty"];
                }
                else if (row["Status"].ToString() == "Obsolete")
                {
                    e.Style = c1FlexGrid1.Styles["Obsolete"];
                }
            }
        }

        /// <summary>
        /// Gets sample data for the grid
        /// </summary>
        private DataTable GetData()
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Id");
            dt.Columns.Add("ProductName");
            dt.Columns.Add("Status");


            for (int i = 1; i <= 10000; i++)
            {
                if (i % 3 == 0)
                    dt.Rows.Add(i, $"Product {i}", "Obsolete");
                else if (i % 2 == 0)
                    dt.Rows.Add(i, $"Product {i}", "Faulty");
                else
                    dt.Rows.Add(i, $"Product {i}", "Working");
            }

            return dt;
        }
    }
}
